org.apache.ignite.internal.util.future

## Class IgniteRemoteMapTask<T,R>

- java.lang.Object
- - org.apache.ignite.compute.ComputeTaskAdapter<T,R>
  - - org.apache.ignite.internal.util.future.IgniteRemoteMapTask<T,R>

All Implemented Interfaces:
  Serializable, ComputeTask<T,R>

    @GridInternal
    public class IgniteRemoteMapTask<T,R>
    extends ComputeTaskAdapter<T,R>

Util task that will execute ComputeTask on a given node.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`IgniteRemoteMapTask(ClusterNode node, ComputeTask<T,R> remoteTask)`

### Method Summary

All Methods Instance Methods Concrete Methods
`Map<? extends ComputeJob,ClusterNode>` `map(List<ClusterNode> subgrid, T arg)` This method is called to map or split grid task into multiple grid jobs.
`R` `reduce(List<ComputeJobResult> results)` Reduces (or aggregates) results received so far into one compound result to be returned to caller via `ComputeTaskFuture.get()` method.

### Methods inherited from class org.apache.ignite.compute.ComputeTaskAdapter

`result`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### IgniteRemoteMapTask

    public IgniteRemoteMapTask(ClusterNode node,
                               ComputeTask<T,R> remoteTask)

Parameters:
  `node` - Target node.
  `remoteTask` - Delegate task.

### Method Detail

#### map

    @Nullable
    public Map<? extends ComputeJob,ClusterNode> map(List<ClusterNode> subgrid,
                                                               @Nullable
                                                               T arg)
                                                        throws IgniteException

This method is called to map or split grid task into multiple grid jobs. This is the first method that gets called when task execution starts.

Parameters:
  `subgrid` - Nodes available for this task execution. Note that order of nodes is guaranteed to be randomized by container. This ensures that every time you simply iterate through grid nodes, the order of nodes will be random which over time should result into all nodes being used equally.
  `arg` - Task execution argument. Can be `null`. This is the same argument as the one passed into `Grid#execute(...)` methods.
Returns:
  Map of grid jobs assigned to subgrid node. Unless `ComputeTaskContinuousMapper` is injected into task, if `null` or empty map is returned, exception will be thrown.
Throws:
  `IgniteException` - If mapping could not complete successfully. This exception will be thrown out of `ComputeTaskFuture.get()` method.

#### reduce

    @Nullable
    public R reduce(List<ComputeJobResult> results)
                       throws IgniteException

Reduces (or aggregates) results received so far into one compound result to be returned to caller via `ComputeTaskFuture.get()` method.

Note, that if some jobs did not succeed and could not be failed over then the list of results passed into this method will include the failed results. Otherwise, failed results will not be in the list.

Parameters:
  `results` - Received results of broadcasted remote executions. Note that if task class has `ComputeTaskNoResultCache` annotation, then this list will be empty.
Returns:
  Grid job result constructed from results of remote executions.
Throws:
  `IgniteException` - If reduction or results caused an error. This exception will be thrown out of `ComputeTaskFuture.get()` method.

2018 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 2.6.0
Release Date | : July 10 2018